// An individual Particle

class Particle {

  // Velocity
  PVector center;
  PVector velocity;
  // Lifespane is tied to alpha
  float lifespan;

  // The particle PShape
  PShape part;
  // The particle size
  float partSize;
  PVector fillColor;
  PVector strokeColor;

  // A single force
  PVector gravity = new PVector(0, 0.1);

  Particle(PVector vec) {    
    partSize = random(1, 3);
    // The particle is a textured quad
    part = createShape();
    part.beginShape(QUAD);
    //212,181,106
    //part.colorMode(HSB,100);
    fillColor = new PVector(random(255), random(255), random(255));
    part.fill(fillColor.x, fillColor.y, fillColor.z);
   // part.noStroke();
   strokeColor = new PVector(random(255), random(255), random(255));
   part.stroke(strokeColor.x, strokeColor.y, strokeColor.z);
    //part.texture(sprite);
    part.normal(0, 0, 1);
    part.vertex(-partSize/2, -partSize/2, 0, 0);
    part.vertex(+partSize/2, -partSize/2, sprite.width, 0);
    part.vertex(+partSize/2, +partSize/2, sprite.width, sprite.height);
    part.vertex(-partSize/2, +partSize/2, 0, sprite.height);
    part.endShape();
    
    // Initialize center vector
    center = vec; 
    
    // Set the particle starting location
    rebirth(vec.x,vec.y);//width/2, height/2);
  }

  PShape getShape() {
    return part;
  }

  void rebirth(float x, float y) {
    float a = random(TWO_PI);
    float speed = random(1,6);//random(0.5, 4);
    // A velocity with random angle and magnitude
    velocity = PVector.fromAngle(a);
    velocity.mult(speed);
    // Set lifespan
    lifespan = random(10,35);
    // Set location using translate
    part.resetMatrix();
    part.translate(x, y); 
    // Update center vector
    center.set(x, y, 0);
  }

  // Is it off the screen, or its lifespan is over?
  boolean isDead() {
   if (center.x > width  || center.x < 0 || 
        center.y > height || center.y < 0 || lifespan < 0) {
      return true;
    } 
    else {
      return false;
    }
  }

  void update() {
    if(!isDead())
    {
        // Decrease life
        lifespan = lifespan - 1;
        // Apply gravity
        velocity.add(gravity);
       // part.setTint(color(255, lifespan));
       part.setFill(color(fillColor.x, fillColor.y, fillColor.z,255-lifespan*2));
       part.setStroke(color(strokeColor.x, strokeColor.y, strokeColor.z, lifespan));
        // Move the particle according to its velocity
        part.translate(velocity.x, velocity.y);
        // and also update the center
        center.add(velocity);
    }
  }
}