/**
 * ParticleSystemPShape
 * 
 * A particle system optimized for drawing using PShape
 */

// Particle System object
ParticleSystem ps;
ArrayList<ParticleSystem> systems;
// A PImage for particle's texture
int pointCount; 
PImage sprite;

void setup() {
  size(1000, 600, P2D);
  // Load the image
   systems = new ArrayList<ParticleSystem>();
   sprite = loadImage("sprite.png");
    pointCount = 0;
  // Writing to the depth buffer is disabled to avoid rendering
  // artifacts due to the fact that the particles are semi-transparent
  // but not z-sorted.
  hint(DISABLE_DEPTH_MASK);

} 

void mousePressed() {
  systems.add(new ParticleSystem(1000, new PVector(mouseX, mouseY)));
}

void draw () {
  background(#390035);
  // Update and display system
   for (ParticleSystem ps: systems) {
    ps.update();
    ps.display();
  }
  // Set the particle system's emitter location to the mouse
  //ps.setEmitter(mouseX,mouseY);
  if(pointCount%20 ==0 && pointCount < 180)
  {
    systems.add(new ParticleSystem(1000, new PVector(random(0,width), random(0,height)))); 
  }
   pointCount++;
  
  // Display frame rate
  fill(255);
  textSize(16);
  //text("Frame rate: " + int(frameRate),10,20);
  saveFrame("line-######.png");
  
}